/*
 *  event.h
 *  
 *
 *  Created by Tesnim ABDELLATIF on 6/25/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef EVENT_H
#define EVENT_H
#include <list>
#include "port.h"
#include "structure.h"


/******************************************
 * Class: Event
 * Description: external events base class
 *****************************************/
class Event;

class Event {

  /*** Protected data members ***/
  protected:
    char*     Name;        /* Name of the event */
	bool      present;     /* Boolean to check the presence of the event */
	bool      synced;      /* An event for witch a port is waiting to be inabled */
       
  /*** Mutex pour l'accés aux Events ***/
  protected:
        //pthread_mutex_t event_lock; //= PTHREAD_MUTEX_INITIALIZER;
        
  /*** Constructors & Dectructors ***/
  public:
    Event(const char*);
    virtual ~Event();


  /*** Public Data-Access Methods ***/
  public:    
   inline char*     name()              const   { return Name; }
  
   virtual Port*    holder()            const   { return NULL; }
   virtual void     setholder(Port *)           {}
	
	bool ispresent();
	void setpresent(bool presence);
	bool issynced();  
    void setsynced(bool sync);
 };
 
#endif
  
