#include <stdio.h>
#include <string.h>

#include "aperiodic2.h"

// initialization function
void aperiodic2_init(DOLCProcess *p) {
	p->local->index = 30;
}

// fire function
void aperiodic2_fire(DOLCProcess *p, int mode) {

	switch (mode) {
	case MODE_NORMAL: {
		PHASE("mode_normal");
	
		// Write p->local->index to data channel
		DOLCDataVar(int, writeData);
		writeData.valid = true;
		*((int *)writeData.ptr) = p->local->index;
		int r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (!r) {
			printf("APeriodic 2: Activated with index %d, sent data %d\n", p->local->index, *((int *)writeData.ptr));
			fflush(stdout);
		} else {
			printf("APeriodic 2: Activated with index %d, write not successful\n", p->local->index);
			fflush(stdout);
		}

		break;
	}

	default:
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void aperiodic2_terminate(DOLCProcess *p) {
	fflush(stdout);
}
