#include <stdio.h>
#include <string.h>

#include "periodic4.h"

// initialization function
void periodic4_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void periodic4_fire(DOLCProcess *p, int mode) {

	DOLCDataVar(int, writeData);
    int r;

	switch (mode) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
		// Write p->local->index to data channel
		writeData.valid = true;
		*((int *)writeData.ptr) = p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (!r) {
			printf("Periodic 4: Activated with index %d, sent data %d\n", p->local->index, *((int *)writeData.ptr));
			fflush(stdout);
		} else {
			printf("Periodic 4: Activated with index %d, write not successful\n", p->local->index);
			fflush(stdout);
		}

		break;	

	default:
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void periodic4_terminate(DOLCProcess *p) {
	fflush(stdout);
}
