#include <stdio.h>
#include <string.h>

#include "percons.h"

// initialization function
void percons_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void percons_fire(DOLCProcess *p, int modeCons) {
	DOLCDataVar(int, readData);
    readData.valid = true;

	switch (modeCons) {

	case MODE_DEGRADED: 
		PHASE("mode_degraded");
		printf("Consumer: ERROR Activated with index %d, MODE DEGRADED???\n", p->local->index);
	    fflush(stdout);
		break;
	

	case MODE_NORMAL: 
		PHASE("mode_normal");

		// Read data from data channel
        while (readData.valid){
            DOLC_read((void*) PORT_IN, &(readData), 1, p);

            if (readData.valid) {
                printf("Consumer: INFO: Activated with index %d, read %d\n", p->local->index, dolcdata_readData);
                fflush(stdout);
            } else {
                printf("Consumer: INFO: Activated with index %d, no new data available\n",	p->local->index);
                fflush(stdout);
            }
        }
        break;


	default:
		break;
	}

	p->local->index++;

	return;
}

// finish function
void percons_terminate(DOLCProcess *p) {
	fflush(stdout);
}
