#include <stdio.h>
#include <string.h>

#include "periodic2.h"

// initialization function
void periodic2_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void periodic2_fire(DOLCProcess *p, int modeCons) {
	DOLCDataVar(int, readData);

	switch (modeCons) {
	case MODE_DEGRADED: 
		PHASE("mode_degraded");

		// Read data from data channel
		DOLC_read((void*) PORT_IN, &(readData), 1, p);

		if (readData.valid) {
			printf("Periodic 2 (mode 0): Activated with index %d, read %d\n", p->local->index, dolcdata_readData);
			fflush(stdout);
		} else {
			printf("Periodic 2 (mode 0): Activated with index %d, no new data available\n", p->local->index);
			fflush(stdout);
		}
		break;
	

	case MODE_NORMAL: 
		PHASE("mode_normal");

		// Read data from data channel
		DOLC_read((void*) PORT_IN, &(readData), 1, p);

		if (readData.valid) {
			printf("Periodic 2 (mode 1): Activated with index %d, read %d\n", p->local->index, dolcdata_readData);
			fflush(stdout);
		} else {
			printf("Periodic 2 (mode 1): Activated with index %d, no new data available\n",	p->local->index);
			fflush(stdout);
		}
		break;


	default:
		break;
	}

	p->local->index++;

	return;
}

// finish function
void periodic2_terminate(DOLCProcess *p) {
	fflush(stdout);
}
