#include <string.h>

#include "aperprod.h"


// initialization function
void aperprod_init(DOLCProcess *p) {
	p->local->index = 0;
	p->local->modeOfPeriodic2 = 1;
}

// fire function
void aperprod_fire(DOLCProcess *p, int modeProd) {
    DOLCDataVar(int, writeData);
    int r;
    int write_success = 0;
	switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
		// Write delta + p->local->index to data channel
		writeData.valid = true;
		dolcdata_writeData = 123000000 + p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (r==write_success) {
			printf("Producer: INFO   Activated with index %d send data %d\n", p->local->index, dolcdata_writeData);
			fflush(stdout);
		} else {
			printf("Producer: ERROR Activated with index %d,  WRITE FAILED (mailbox full?)\n", p->local->index);
			fflush(stdout);
		}

       break;

	default:
		printf("Producer: ERROR Activated with index %d, MODE DEGRADED???\n", p->local->index);
		fflush(stdout);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void aperprod_terminate(DOLCProcess *p) {
	fflush(stdout);
}
